#ifndef EFL_CONTROL_EO_HH
#define EFL_CONTROL_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_control.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Control;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Control> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Control {
   ::efl::eolian::return_traits<int>::type priority_get() const;
   ::efl::eolian::return_traits<void>::type priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   ::efl::eolian::return_traits<bool>::type suspend_get() const;
   ::efl::eolian::return_traits<void>::type suspend_set( ::efl::eolian::in_traits<bool>::type suspend) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CONTROL_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Control() const;
   operator ::efl::Control&();
   operator ::efl::Control const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Control> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Control const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Control : ::efl::eo::concrete
{
   explicit Control( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Control(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Control(Control const& other) = default;
   Control(Control&& other) = default;
   Control& operator=(Control const& other) = default;
   Control& operator=(Control&& other) = default;
   Control()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Control( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Control(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type priority_get() const;
   ::efl::eolian::return_traits<void>::type priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   ::efl::eolian::return_traits<bool>::type suspend_get() const;
   ::efl::eolian::return_traits<void>::type suspend_set( ::efl::eolian::in_traits<bool>::type suspend) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CONTROL_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Control> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Control const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Control) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Control>::value, "");
} 
#include "efl_control.eo.impl.hh"
#endif
